package weaver.interfaces.nbjh.action;

import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.RequestInfo;

/**
 * @Title
 * @Author wangchaofa
 * @CreateDate 2024/1/8
 * @Version 1.0
 * @Description
 */
public class UpdateJbtzDatetimeAction extends BaseBean implements Action {
    @Override
    public String execute(RequestInfo requestInfo) {
        try{
            String tablename = requestInfo.getRequestManager().getBillTableName();
            String detailtable = tablename+"_dt1";
            String requestid = requestInfo.getRequestid();

            RecordSet rs = new RecordSet();
            RecordSet rst = new RecordSet();
            rs.executeQuery("select a.resourceId,b.* from "+ tablename +" a,"+ detailtable +" b where a.id=b.mainid and a.requestid=?",requestid);
            while(rs.next()){
                String userid = Util.null2String(rs.getString("resourceId"));
                // 补卡类型  0 上班  1 下班
                int detail_signtype = Util.getIntValue(rs.getString("detail_signtype"));
                //补卡日期 2024-01-01
                String detail_signdate = Util.null2String(rs.getString("detail_signdate"));
                //补卡时间 10:10
                String detail_signtime = Util.null2String(rs.getString("detail_signtime"));
                if(detail_signtime!=null && !"".equals(detail_signtime)) {
                    detail_signtime = detail_signtime + ":00";
                }
                String signdatetime = detail_signdate+" "+detail_signtime;
                String sql = "";
                boolean bool = false;
                //上班卡
                if(detail_signtype == 0){
                    sql = "update uf_jbtz set zzdksj=? where jbr=? and ksrq=?";
                    bool = rst.executeUpdate(sql,signdatetime,userid,detail_signdate);
                    writeLog("================== update uf_jbtz zzdksj result ==============="+ bool);
                }else{
                    sql="update uf_jbtz set zwdkrq=? where jbr=? and jsrq=?";
                    bool = rst.executeUpdate(sql,signdatetime,userid,detail_signdate);
                    writeLog("================= update uf_jbtz zwdkrq result ================"+ bool);
                }
            }
        }catch (Exception e){
            e.printStackTrace();
            writeLog(e);
        }
        return Action.SUCCESS;
    }
}
